package com.mortals.xhx.module.ent.model;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;
import cn.hutool.core.date.DateUtil;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.mortals.framework.annotation.Excel;
import com.mortals.framework.model.BaseEntityLong;
import com.mortals.xhx.module.ent.model.vo.EntLifeMatterSubVo;
import lombok.Data;
/**
 * 企业周期事项子实体对象
 *
 * @author zxfei
 * @date 2025-03-17
 */
@Data
public class EntLifeMatterSubEntity extends EntLifeMatterSubVo {
    private static final long serialVersionUID = 1L;

    /**
     * 主事项id
     */
    private Long masterRecordId;
    /**
     * 事项id
     */
    private Long matterId;
    /**
     * 事项名称
     */
    private String matterName;
    /**
     * 事项编码
     */
    private String matterCode;
    /**
     * 区域编码
     */
    private String areaCode;
    /**
     * 区域名称
     */
    private String areaName;
    /**
     * 区域等级(1.省，2.地市州，3.区县，4.街道，5.社区)
     */
    private Integer areaLevel;
    /**
     * 办理单位ID
     */
    private Long deptId;
    /**
     * 办理单位名称
     */
    private String deptName;
    /**
     * 备注
     */
    private String remark;
    /**
     * 创建用户名称
     */
    private String createUserName;
    /**
     * 排序字段
     */
    private Integer sort;
    @Override
    public int hashCode() {
        return this.getId().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null) return false;
        if (obj instanceof EntLifeMatterSubEntity) {
            EntLifeMatterSubEntity tmp = (EntLifeMatterSubEntity) obj;
            if (this.getId() == tmp.getId()) {
                return true;
            }
        }
        return false;
    }

    public void initAttrValue(){
        this.masterRecordId = null;
        this.matterId = null;
        this.matterName = "";
        this.matterCode = "";
        this.areaCode = "";
        this.areaName = "";
        this.areaLevel = 1;
        this.deptId = null;
        this.deptName = "";
        this.remark = "";
        this.createUserName = "";
        this.sort = 0;
    }
}